unit TableU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Tablist, Spin, ExtCtrls;

const CHAINWIDTH = 5;

type
  TF_Table = class(TForm)
    M_Table: TMemo;
    Panel1: TPanel;
    S_LL: TSpinEdit;
    B_Calc: TButton;
    B_Open: TButton;
    B_Save: TButton;
    B_Close: TButton;
    procedure B_CloseClick(Sender: TObject);
    procedure B_CalcClick(Sender: TObject);
    procedure B_OpenClick(Sender: TObject);
    procedure B_SaveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  F_Table: TF_Table;

implementation

uses ChainU;

{$R *.DFM}

procedure TF_Table.B_CalcClick(Sender: TObject);
var
  x, x_width, y, upper : integer;
  s, t : string;
begin
  M_Table.Clear;
  Upper := S_LL.value;
  ChainU.maxLL := Upper;
  ChainU.CalcLLTabel;
  M_Table.Lines.add('  n L(n) LL(m,n) - L(n)');
  M_Table.Lines.add('-----------------------');
  for y := 1 to upper do
  begin
    s := '  ' + inttostr(y);
    s := copy(s, length(s) - 2, 3);
    t := '  ' + inttostr(ChainU.L[y]);
    t := copy(t, length(t) - 2, 3);
    s := s + '  ' + t + ' ';
    for x_width := 0 to y div CHAINWIDTH do
    begin
      for x := 1 to CHAINWIDTH do
        if x_width * CHAINWIDTH + x < y then
          s := s + inttostr(ChainU.LL[x_width*CHAINWIDTH+x,y] - ChainU.L[y]);
      s := s + ' ';
    end;
    M_Table.Lines.add(s);
  end;
  M_Table.Lines.add('-----------------------');
  M_Table.Lines.add('---   Chain Data    ---');
  M_Table.Lines.add('-----------------------');
  M_Table.Lines.add('  n L(n) Chaindata');
  M_Table.Lines.add('-----------------------');
  for y := 1 to upper do
  begin
    s := '  ' + inttostr(y);
    s := copy(s, length(s) - 2, 3);
    t := '  ' + inttostr(ChainU.L[y]);
    t := copy(t, length(t) - 2, 3);
    s := s + ' ' + t + '  ';
    for x := 1 to y do
    begin
      t := ' ' + inttostr(ChainU.ChainData[x,y]);
      t := copy(t, length(t) - 1, 2);
      s := s + t + '.';
    end;
    M_Table.Lines.add(s);
  end;
  M_Table.Lines.add('-----------------------');
  M_Table.Lines.add('---   Differences   ---');
  M_Table.Lines.add('-----------------------');
  M_Table.Lines.add('  n L(n) High - Low');
  M_Table.Lines.add('-----------------------');
  for y := 1 to upper do
  begin
    s := '  ' + inttostr(y);
    s := copy(s, length(s) - 2, 3);
    t := '  ' + inttostr(ChainU.L[y]);
    t := copy(t, length(t) - 2, 3);
    s := s + ' ' + t + ' ';
    for x_width := 0 to y div CHAINWIDTH do
    begin
      for x := 1 to CHAINWIDTH do
        if x_width * CHAINWIDTH + x < y then
          s := s + inttostr( ChainU.LL[x_width*CHAINWIDTH+x,y] -
                             ChainU.DD[x_width*CHAINWIDTH+x,y]);
      s := s + ' ';
    end;
    M_Table.Lines.add(s);
  end;
end;

procedure TF_Table.B_OpenClick(Sender: TObject);
var
  F: TextFile;
  x, y, maxLL, x_width : integer;
  c : char;
  s, t : string;
begin
  M_Table.Clear;
  AssignFile(F, 'addition.dat');
  Reset(F);
  Readln(F, maxLL);
  chainU.maxLL := maxLL;
  for y := 1 to maxLL do
  begin
    Read(F, x, c);
    if x <> y then
    begin
      showmessage('1:Wrong structure at '+inttostr(y)+', '+ inttostr(x)+' instead of '+inttostr(y));
      exit;
    end;
    while c = ' ' do Read(F, c);
    if c <> '>' then
    begin
      showmessage('2:Wrong structure at '+inttostr(y)+', #'+ inttostr(ord(c))+' instead of <space>');
      exit;
    end;
    Read(F, ChainU.L[y], c);
    while c = ' ' do Read(F, c);
    if c <> '>' then
    begin
      showmessage('3:Wrong structure at '+inttostr(y)+', #'+ inttostr(ord(c))+' instead of <space>');
      exit;
    end;
    ChainU.LL[1,y] := ChainU.L[y];
    ChainU.LL[2,y] := ChainU.L[y];
    ChainU.LL[y-2,y] := ChainU.L[y-2] + 1;
    ChainU.LL[y-1,y] := ChainU.L[y-1] + 1;
    ChainU.DD[1,y] := ChainU.L[y];
    ChainU.DD[2,y] := ChainU.L[y];
    ChainU.DD[y-2,y] := ChainU.L[y-2] + 1;
    ChainU.DD[y-1,y] := ChainU.L[y-1] + 1;
    for x := 3 to y - 3 do
    begin
      Read(F, c);
      ChainU.LL[x,y] := ChainU.L[y] + ord(c) - 48;
      ChainU.DD[x,y] := ChainU.LL[x,y];
    end;
    Read(F, c); {space}
    while c = ' ' do Read(F, c);
    if c <> '>' then
    begin
      showmessage('4:Wrong structure at '+inttostr(y)+', #'+ inttostr(ord(c))+' instead of <space>');
      exit;
    end;
    for x := 1 to y do
    begin
      Read(F, c);
      ChainU.ChainData[x,y] := ord(c) - 64;
    end;
    Readln(F);
  end;
  CloseFile(F);
  M_Table.Lines.add('  n L(n) LL(m,n) - L(n)');
  M_Table.Lines.add('-----------------------');
  for y := 1 to maxLL do
  begin
    s := '  ' + inttostr(y);
    s := copy(s, length(s) - 2, 3);
    t := '  ' + inttostr(ChainU.L[y]);
    t := copy(t, length(t) - 2, 3);
    s := s + '  ' + t + ' ';
    for x_width := 0 to y div CHAINWIDTH do
    begin
      for x := 1 to CHAINWIDTH do
        if x_width * CHAINWIDTH + x < y then
          s := s + inttostr(ChainU.LL[x_width*CHAINWIDTH+x,y] - ChainU.L[y]);
      s := s + ' ';
    end;
    M_Table.Lines.add(s);
  end;
  M_Table.Lines.add('-----------------------');
  M_Table.Lines.add('---   Chain Data    ---');
  M_Table.Lines.add('-----------------------');
  M_Table.Lines.add('  n L(n) Chaindata');
  M_Table.Lines.add('-----------------------');
  for y := 1 to maxLL do
  begin
    s := '  ' + inttostr(y);
    s := copy(s, length(s) - 2, 3);
    t := '  ' + inttostr(ChainU.L[y]);
    t := copy(t, length(t) - 2, 3);
    s := s + ' ' + t + '  ';
    for x := 1 to y do
    begin
      t := ' ' + inttostr(ChainU.ChainData[x,y]);
      t := copy(t, length(t) - 1, 2);
      s := s + t + '.';
    end;
    M_Table.Lines.add(s);
  end;
end;

procedure TF_Table.B_SaveClick(Sender: TObject);
var
  F: TextFile;
  x, y, maxLL : integer;
  c : char;
begin
  maxLL := chainU.maxLL;
  AssignFile(F, 'addition.dat');
  Rewrite(F);
  Writeln(F, maxLL);
  for y := 1 to maxLL do
  begin
    Write(F, y, ' >', ChainU.L[y], ' >');
    for x := 3 to y - 3 do Write(F, ChainU.LL[x,y]- ChainU.L[y]);
    Write(F, ' >');
    for x := 1 to y do
    begin
      c := chr(64 + ChainU.ChainData[x,y]);
      Write(F, c);
    end;
    Writeln(F);
  end;
  CloseFile(F);
end;

procedure TF_Table.B_CloseClick(Sender: TObject);
begin
  Close;
end;

end.
